SET SQL_MODE = "NO_AUTO_VALUE_ON_ZERO";
SET time_zone = "+00:00";


/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;

# Выборка всех студентов, с повторяющимися именами
SELECT distinct st1.*
FROM students as st1
WHERE (
    SELECT count(*) from students as st
    where CONCAT( st.LastName, st.FirstName, st.SecondName )
        LIKE CONCAT( st1.LastName, st1.FirstName, st1.SecondName)
    ) > 1
ORDER BY LastName


# выборка всех оценок для студента (с учетом повторений)
SELECT students.ID AS  "StudentID", students.LastName, rating_table . *
    FROM students
    LEFT JOIN rating_table ON rating_table.StudentID = students.ID
    WHERE CONCAT( students.LastName, students.FirstName, students.SecondName ) LIKE (
        SELECT CONCAT( st.LastName, st.FirstName, st.SecondName )
        FROM students AS st
        WHERE st.id =133
    )
ORDER BY SubmoduleID



# студенты, повторно привязанные к дисциплинам
SELECT students.ID as "StudentID",
        students.LastName,
        disciplines_students.ID as "disciplines_studentsID"
FROM students
left join disciplines_students on disciplines_students.StudentID = students.ID
WHERE CONCAT( students.LastName, students.FirstName, students.SecondName) LIKE (
        SELECT CONCAT( st.LastName, st.FirstName, st.SecondName )
        from students as st
        where st.id = 133
    )


# дублирование оценок
SELECT distinct st1.*, rating_table.SubmoduleID, count(*) as "cnt"
FROM students as st1
LEFT JOIN rating_table on rating_table.StudentID = st1.ID
WHERE CONCAT( st1.LastName, st1.FirstName, st1.SecondName ) LIKE (
        SELECT CONCAT( st.LastName, st.FirstName, st.SecondName )
        FROM students AS st
        WHERE st.id = # studentID
    )
GROUP BY st1.LastName, rating_table.SubmoduleID
ORDER BY cnt desc

# студенты - дубликаты
select CONCAT(students.LastName,' ',students.FirstName,' ',students.SecondName) as name,
    t.disciplineID,
    t.id as logID,
    t.StudentID
from (
    SELECT max(logs_binds_students.id) as id, StudentID, DisciplineID, Type
    from logs_binds_students
    GROUP by logs_binds_students.StudentID, logs_binds_students.DisciplineID
) as t2
inner join logs_binds_students as t on t2.id = t.id
inner join disciplines on disciplines.id = t.DisciplineID
inner join students_groups on students_groups.StudentID = t.StudentID and students_groups.SemesterID = disciplines.SemesterID
inner join students on students.id = t.studentid

left join disciplines_groups on disciplines_groups.DisciplineID = t.DisciplineID and disciplines_groups.GroupID = students_groups.GroupID
left join disciplines_students on disciplines_students.StudentID = t.StudentID and disciplines_students.DisciplineID = t.DisciplineID

where t.Type = 'attach'
    and disciplines_students.id is null
    and disciplines_groups.id is null


-- список дубликатов и кол-во их оценок
select  t1.name,
        t1.recentSt,
        t1.lastSt,
        t2.cnt as beforeCnt,
        t3.cnt as afterCnt,
        tac1.Login IS NOT NULL,
        tac2.Login IS NOT NULL
from (
    select min(students.id) as recentSt, min(students.AccountID) as recentAcc,
            max(students.id) as lastSt, max(students.AccountID) as lastAcc,
            CONCAT( students.LastName, ' ', students.FirstName, ' ', students.SecondName) as name
    from students
    group by CONCAT( students.LastName, students.FirstName, students.SecondName)
    having count(*) > 1
) as t1
left join accounts as tac1 on tac1.id = t1.recentAcc
left join accounts as tac2 on tac2.id = t1.lastAcc
left join (
    select  count(rating_table.Rate) as cnt,
            CONCAT( students.LastName, ' ', students.FirstName, ' ', students.SecondName) as name
    from students
    left join rating_table on students.id = rating_table.StudentID
    where rating_table.Rate IS NOT NULL
    group by CONCAT( students.LastName, ' ', students.FirstName, ' ', students.SecondName)
) as t2 on STRCMP(t2.name, t1.name) = 0
left join (
    select t4.name,
            count(*) as cnt
    from (
        select  count(rating_table.Rate) as cnt,
                CONCAT( students.LastName, ' ', students.FirstName, ' ', students.SecondName) as name
        from students
        left join rating_table on students.id = rating_table.StudentID
        where rating_table.Rate IS NOT NULL
        group by CONCAT( students.LastName, ' ', students.FirstName, ' ', students.SecondName), rating_table.submoduleID
    ) as t4
    group by t4.name
) as t3 on STRCMP(t3.name, t1.name) = 0
order by t1.recentSt

